# Supported formats

Immich supports a number of image and video formats, the most common of which are outlined here.

:::note
For the full list, refer to the [Immich source code](https://github.com/immich-app/immich/blob/main/server/src/utils/mime-types.ts).
:::

## Image formats

| Format    | Extension(s)                  |     Supported?     | Notes           |
| :-------- | :---------------------------- | :----------------: | :-------------- |
| `AVIF`    | `.avif`                       | :white_check_mark: |                 |
| `BMP`     | `.bmp`                        | :white_check_mark: |                 |
| `GIF`     | `.gif`                        | :white_check_mark: |                 |
| `HEIC`    | `.heic`                       | :white_check_mark: |                 |
| `HEIF`    | `.heif`                       | :white_check_mark: |                 |
| `JPEG`    | `.jpeg` `.jpg` `.jpe` `.insp` | :white_check_mark: |                 |
| `JPEG XL` | `.jxl`                        | :white_check_mark: |                 |
| `PNG`     | `.png`                        | :white_check_mark: |                 |
| `PSD`     | `.psd`                        | :white_check_mark: | Adobe Photoshop |
| `RAW`     | `.raw`                        | :white_check_mark: |                 |
| `RW2`     | `.rw2`                        | :white_check_mark: |                 |
| `SVG`     | `.svg`                        | :white_check_mark: |                 |
| `TIFF`    | `.tif` `.tiff`                | :white_check_mark: |                 |
| `WEBP`    | `.webp`                       | :white_check_mark: |                 |

## Video formats

| Format      | Extension(s)          |     Supported?     | Notes |
| :---------- | :-------------------- | :----------------: | :---- |
| `3GPP`      | `.3gp` `.3gpp`        | :white_check_mark: |       |
| `AVI`       | `.avi`                | :white_check_mark: |       |
| `FLV`       | `.flv`                | :white_check_mark: |       |
| `M4V`       | `.m4v`                | :white_check_mark: |       |
| `MATROSKA`  | `.mkv`                | :white_check_mark: |       |
| `MP2T`      | `.mts` `.m2ts`        | :white_check_mark: |       |
| `MP4`       | `.mp4` `.insv`        | :white_check_mark: |       |
| `MPEG`      | `.mpg` `.mpe` `.mpeg` | :white_check_mark: |       |
| `QUICKTIME` | `.mov`                | :white_check_mark: |       |
| `WEBM`      | `.webm`               | :white_check_mark: |       |
| `WMV`       | `.wmv`                | :white_check_mark: |       |
